Package org.apache.commons.compress.java.util.jar

# Interface Pack200.Unpacker

All Known Implementing Classes:
  `Pack200UnpackerAdapter`

Enclosing class:
  `Pack200`

public static interface Pack200.Unpacker
The interface defining the API for converting a packed stream in the Pack200 format to a JAR file.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `DEFLATE_HINT`
  The String indicating if the unpacker should ignore all transmitted values, can be replaced by either `true` or `false`.
  `static final String`
  `FALSE`
  a String representation of `false`.
  `static final String`
  `KEEP`
  a String representation of `keep`.
  `static final String`
  `PROGRESS`
  The progress as a `percentage`.
  `static final String`
  `TRUE`
  a String representation of `true`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Adds a listener for `PropertyChange` events.
  `SortedMap<String,String>`
  `properties()`
  Gets a sorted map of the properties of this unpacker.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Removes a listener.
  `void`
  `unpack(File in, JarOutputStream out)`
  Unpacks the contents of the specified `File` to the specified JAR output stream.
  `void`
  `unpack(InputStream in, JarOutputStream out)`
  Unpacks the specified stream to the specified JAR output stream.

- ## Field Details

  - ### DEFLATE_HINT

    static final String DEFLATE_HINT
    The String indicating if the unpacker should ignore all transmitted values, can be replaced by either `true` or `false`.
    See Also:
      - Constant Field Values

  - ### FALSE

    static final String FALSE
    a String representation of `false`.
    See Also:
      - Constant Field Values

  - ### KEEP

    static final String KEEP
    a String representation of `keep`.
    See Also:
      - Constant Field Values

  - ### PROGRESS

    static final String PROGRESS
    The progress as a `percentage`.
    See Also:
      - Constant Field Values

  - ### TRUE

    static final String TRUE
    a String representation of `true`.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### addPropertyChangeListener

    void addPropertyChangeListener(PropertyChangeListener listener)
    Adds a listener for `PropertyChange` events.
    Parameters:
      `listener` - the listener to listen if `PropertyChange` events occurs.

  - ### properties

    SortedMap<String,String> properties()
    Gets a sorted map of the properties of this unpacker.
    Returns:
      the properties of unpacker.

  - ### removePropertyChangeListener

    void removePropertyChangeListener(PropertyChangeListener listener)
    Removes a listener.
    Parameters:
      `listener` - listener to remove.

  - ### unpack

    void unpack(File in, JarOutputStream out) throws IOException
    Unpacks the contents of the specified `File` to the specified JAR output stream.
    Parameters:
      `in` - file to uncompress.
      `out` - JAR output stream of uncompressed data.
    Throws:
      `IOException` - if I/O exception occurs.

  - ### unpack

    void unpack(InputStream in, JarOutputStream out) throws IOException
    Unpacks the specified stream to the specified JAR output stream.
    Parameters:
      `in` - stream to uncompress, preferably a `BoundedInputStream`.
      `out` - JAR output stream of uncompressed data.
    Throws:
      `IOException` - if I/O exception occurs.